﻿Imports System.Runtime.CompilerServices
Imports System.Data.Common
Imports System.Reflection
Imports System.ComponentModel
Imports System.Text.RegularExpressions

Namespace System.Data

   Public Module DataCommonX

#Region "ConnectionOpening"
      Private _ConnectionWatchers As New ComponentProperty(Of DbConnection, ConditionalActionFrame)(AddressOf CreateActionFrame)

      Private Function CreateActionFrame(ByVal conn As DbConnection) As ConditionalActionFrame
         Return New ConditionalActionFrame(Function() conn.State = ConnectionState.Closed, AddressOf conn.Open, AddressOf conn.Close)
      End Function

      <DebuggerStepThrough()> _
      <System.Runtime.CompilerServices.Extension()> _
      Public Function EnterOpen(ByVal conn As DbConnection) As IDisposable
         Return _ConnectionWatchers(conn).Enter()
      End Function

#End Region 'ConnectionOpening

#Region "Data.Common-Objekte klonen"

      <System.Runtime.CompilerServices.Extension()> _
      Public Function Clone(ByVal cmd As DbCommand) As DbCommand
         Return DirectCast(DirectCast(cmd, ICloneable).Clone(), DbCommand)
      End Function
      <System.Runtime.CompilerServices.Extension()> _
      Public Function Clone(ByVal param As DbParameter) As DbParameter
         Return DirectCast(DirectCast(param, ICloneable).Clone(), DbParameter)
      End Function
#End Region

   End Module

End Namespace
