﻿Namespace System

   ''' <summary>can be used as optional parameter </summary>
   ''' <remarks>in 2010 no longer needed</remarks>
   Public Class Nullable2(Of T As Structure)
      Public Value As T
      Public Shared Widening Operator CType(ByVal other As T) As Nullable2(Of T)
         Return New Nullable2(Of T) With {.Value = other}
      End Operator
   End Class

   Public Class Counter
      Private _Value As Integer = 0
      <DebuggerStepThrough()> _
      Public Function Up() As Integer
         Up = _Value
         _Value += 1
      End Function
      <DebuggerStepThrough()> _
      Public Function Down() As Integer
         Down = _Value
         _Value -= 1
      End Function
      <DebuggerStepThrough()> _
      Public Shared Widening Operator CType(ByVal i As Integer) As Counter
         Return New Counter() With {._Value = i}
      End Operator
      <DebuggerStepThrough()> _
      Public Shared Widening Operator CType(ByVal i As Counter) As Integer
         Return i._Value
      End Operator
      <DebuggerStepThrough()> _
      Public Shared Operator &(ByVal left As String, ByVal right As Counter) As String
         Return right._Value.ToString
      End Operator
      <DebuggerStepThrough()> _
      Public Overrides Function ToString() As String
         Return _Value.ToString()
      End Function
   End Class

End Namespace