﻿Imports System.Data.Common
Imports MySql.Data.MySqlClient
Imports MySqlTest.BankenDts

Public Class frmBankenTest

   Private Sub Form_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Dim adp = New DatasetAdapter(MySqlClientFactory.Instance, _
         My.Settings.BankenConnections, ConflictOption.OverwriteChanges)
      Me.AlignOnTop.BankenDts.Adapter(adp).Register(Me).Fill()
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btFillComplete.Click, btFillByBank.Click, btFillByExpression.Click, btFillByParam.Click
      With BankenDts.Adressen
         Select Case True
            Case sender Is btFillComplete
               .Fill()
            Case sender Is btFillByBank
               Dim rwB = srcBanken.At(Of BankenRow)()
               rwB.FillChildTables(BankenDts.Adressen)
            Case Else
               Try
                  Select Case True
                     Case sender Is btFillByExpression
                        .Fill(txtExpression.Text)
                     Case sender Is btFillByParam
                        Dim param = 0
                        If Integer.TryParse(txtParam.Text, param) Then
                           .Fill(txtParamExpression.Text, param)
                        Else
                           .Fill(txtParamExpression.Text, txtParam.Text)
                        End If
                  End Select
               Catch ex As Exception
                  MsgBox("Ups! Fehler im Ausdruck")
               End Try
         End Select
      End With
   End Sub


   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : BankenDts.Fill()
         Case sender Is SaveToolStripMenuItem ': BankenDts.Save(Me)
         Case sender Is TestToolStripMenuItem

            Using con = New MySqlConnection(My.Settings.BankenConnections), cmd = New MySqlCommand("Select * from `Banken`", con)
               con.Open()
               Dim rd = cmd.ExecuteReader
               Dim hasRows = rd.HasRows
               Stop
            End Using

      End Select
   End Sub
End Class
