﻿Imports NorthWind.NorthWindDts
Imports System.Data.OleDb

Public Class frmRefillStore

   Private Sub frmNorthWind_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      'Dim adp = New DatasetAdapter( _
      '   OleDbFactory.Instance, My.Settings.BestellungPrimConnectionString, _
      '   ConflictOption.OverwriteChanges)
      'Me.AlignOnTop.NorthWindDts.Adapter(adp).Register(Me)
      'With Me.NorthWindDts
      '   .Fill(.Kategorien, .Artikel)
      'End With
      Me.NorthWindDts.Register(Me)
   End Sub

   Private Sub ckRefill_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ckRefill.CheckedChanged
      If ckRefill.Checked Then
         NorthWindDts.CheckedCategory.Clear()
         For Each cat As KategorienRow In NorthWindDts.Kategorien
            For Each art In cat.GetArtikelRows
               If art.BestellteEinheiten + art.Lagerbestand < art.Mindestbestand Then
                  ToggleCatChecked(cat)
                  Exit For
               End If
            Next
         Next
         KategorienBindingSource.Filter = "Checked=True"
         ArtikelBindingSource.Filter = "BestellteEinheiten + Lagerbestand < Mindestbestand"
      Else
         KategorienBindingSource.RemoveFilter()
         ArtikelBindingSource.RemoveFilter()
      End If
   End Sub

   Private Sub KategorienDataGridView_CellContentClick(ByVal sender As Object, ByVal e As  _
         DataGridViewCellEventArgs) Handles KategorienDataGridView.CellContentClick
      If e.ColumnIndex <> 0 Then Return
      Dim cat = KategorienBindingSource.At(Of KategorienRow)(e.RowIndex)
      If cat.Null Then Return
      ToggleCatChecked(cat)
   End Sub

   Private Sub ToggleCatChecked(ByVal cat As KategorienRow)
      Dim value = Not cat.Checked
      If value Then
         NorthWindDts.CheckedCategory.AddCheckedCategoryRow(cat)
      Else
         cat.GetCheckedCategoryRows.First.Delete()
      End If
   End Sub

End Class