﻿Imports SqlCeSample.BestellungenDts
Imports System.Data.SqlServerCe

Public Class frmIncrementalFill

   Private Sub frmIncrementalFill_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
      BestellungenDts.Dispose()
   End Sub

   Private Sub Form_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Dim adp = New DatasetAdapter( _
         SqlCeProviderFactory.Instance, My.Settings.BestellungenConnectionString, _
         ConflictOption.OverwriteChanges)
      Me.BestellungenDts.Adapter(adp)
      AddHandler Me.FormClosing, BestellungenDts.HandleFormClosing
      Reload()
   End Sub

   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem
            Reload()
         Case sender Is SaveToolStripMenuItem
            BestellungenDts.Save(Me)
         Case sender Is TestToolStripMenuItem
      End Select
   End Sub

   Private Sub Reload()
      With BestellungenDts
         .Fill(.Bearbeiter, .Kunde)
      End With
   End Sub

   Private Sub BindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) _
         Handles KundeBindingSource.CurrentChanged, BearbeiterBindingSource.CurrentChanged
      'Datenabruf in Abhängigkeit des gewählten Kundes und Bearbeiters
      Dim rwKunde = KundeBindingSource.At(Of KundeRow)()
      Dim rwBearb = BearbeiterBindingSource.At(Of BearbeiterRow)()
      If rwBearb.Null OrElse rwKunde.Null Then Return
      rwKunde.FillChildTable( _
         BestellungenDts.Bestellung, "WHERE BearbeiterID=?", rwBearb.ID)
      lbSqlFromWhere.Text = "WHERE BearbeiterID=?".Replace("?", rwBearb.ID)
   End Sub

End Class
