﻿Imports DatasetOnly.NorthWindDts

Public Class frmArtikels

   Private Sub Form_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Me.NorthWindDts.Register(Me)
      If Me.NorthWindDts.Artikel.Count = 0 Then
         Me.AlignOnTop.NorthWindDts.DataFile("..\..\NorthWind.xml").Fill()
      End If
   End Sub

   Private Sub ArtikelDataGridView_CellDoubleClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles ArtikelDataGridView.CellDoubleClick
      btEdit.PerformClick()
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btAddProduct.Click, btDelete.Click, btEdit.Click
      Select Case True
         Case sender Is btAddProduct
            srcArtikel.AddNew()
            LaunchDetails()
         Case sender Is btEdit
            LaunchDetails()
         Case sender Is btDelete : srcArtikel.RemoveCurrent()
      End Select
   End Sub

   Private Sub LaunchDetails()
      Using frmDetail = New frmArtikelDetails
         'Besonderheit: Die BindingSource des Detail-Forms wird nicht auf eine DataTable
         ' umgesetzt, sondern auf ein einzelnes DataRowView: srcArtikel.Current
         frmDetail.srcArtikel.DataSource = srcArtikel.Current
         If frmDetail.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            frmDetail.srcArtikel.EndEdit()
            srcArtikel.ResetCurrentItem() 'den von der anneren BS geänderten Datensatz neu einlesen.
         Else
            srcArtikel.CancelEdit()
         End If
      End Using
   End Sub

End Class