﻿Imports System.Data.Common

Namespace System.Data

   Public Class DataEditor

      Public Shared Function FromSchema(ByVal con As DbConnection) As DataEditor
         Using con.EnterOpen
            Dim tables = _
               From rw In con.GetSchema("Tables") _
               Where rw("Table_Type").ToString = "TABLE" _
               Select Name = rw("TABLE_NAME").ToString
            Dim tbNames = tables.ToList
            Return New System.Data.DataEditor With {.DataSource = con.GetSchema("Tables")}
         End Using
      End Function

      Public Property DataSource As Object
         Get
            Return Grid.DataSource
         End Get
         Set(ByVal value As Object)
            Grid.DataSource = value
         End Set
      End Property
   End Class

End Namespace