Imports System.Data
Imports System.Data.SQLite
Imports System.IO

Public Class frmSqlLiteTest

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles ReLoadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is ReLoadToolStripMenuItem : Reload()

         Case Sender Is SaveToolStripMenuItem : Save()

         Case Sender Is TestToolStripMenuItem
            OrderDts.Order.Fill("where Text like ?", "b%")
      End Select
   End Sub

   Private Sub Reload()
      OrderDts.Fill()
   End Sub

   Private Sub Save()
      OrderDts.Save(Me)
   End Sub

   Private Sub Form_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Dim sCon = "data source=" & Path.GetFullPath("..\..\OrderDB.s3db")
      Dim adp = New DatasetAdapter(SQLiteFactory.Instance, sCon, ConflictOption.OverwriteChanges)
      Me.OrderDts.Adapter(adp)
      AddHandler Me.FormClosing, OrderDts.HandleFormClosing
   End Sub

End Class